'==============Program rdowy rozszerzony o sterowanie dodatkowej pompy napeniajcej zbiorniki z wod===============
$regfile = "m8def.dat"
$crystal = 8000000

Config Sda = Portb.0
Config Scl = Portb.2

Config Rc5 = Pinb.1 , Timer = 2

Config Portb.3 = Output
Config Portb.4 = Input
Config Portb.5 = Output

Config Portc.0 = Input
Config Portc.1 = Output
Config Portc.2 = Output
Config Portc.3 = Output
Config Portc.4 = Output
Config Portc.5 = Output

Config Portd.0 = Input
Config Portd.1 = Input
Config Portd.2 = Input
Config Portd.3 = Output
'=====================================================aliasy===========================================================
Pompa Alias Portb.3
Termnik Alias Pinb.4
Czujnik_deszczu Alias Pinc.0
L1 Alias Portc.5
L2 Alias Portb.5
L3 Alias Portc.1
L4 Alias Portc.2
Led1 Alias Portc.3
Led2 Alias Portc.4
Czujnik_pelnych_zbiornikow Alias Pind.0
Czujnik_pustych_zbiornikow Alias Pind.1
Dodatkowa_pompa Alias Portd.3
'===================wczenie wewntrznych rezystorw podcigajcych na poszczegulnych wejciach=======================
Termnik = 1
Czujnik_deszczu = 1
L1 = 1
L2 = 1
L3 = 1
L4 = 1
Led1 = 1
Led2 = 1
Pompa = 1
Czujnik_pelnych_zbiornikow = 1
Czujnik_pustych_zbiornikow = 1
Dodatkowa_pompa = 0
Portd.2 = 1
'====================================konfiguracje timerw do odmnierzania czasu========================================
Config Timer0 = Timer , Prescale = 64
Config Timer1 = Timer , Prescale = 64
'===============================================konfiguracja watchdoga=================================================
Config Watchdog = 2048

On Ovf0 Wyswietlacz
On Ovf1 Przerwanie
'============================================deklaracje procedur=======================================================
Declare Sub Program
Declare Sub Zapisz_pamiec
Declare Sub Odczyt_pamieci
'===========================================deklaracjie zmiennych======================================================
Dim Address As Byte , Command As Byte
Dim Gg_pomoc As Byte , Mm_pomoc As Byte , Pomoc_gg As Byte , Pomoc_mm As Byte
Dim Licznik As Byte , Podprogram As Bit
Dim Wysw As Byte , Wysw_pomoc As Byte , Jed_godz As Byte , Jed_min As Byte , Dzi_godz As Byte , Dzi_min As Byte
Dim Z1_on_gg As Byte , Z2_on_gg As Byte , Z3_on_gg As Byte , Z4_on_gg As Byte , Z5_on_gg As Byte , Z6_on_gg As Byte , Z7_on_gg As Byte , Z8_on_gg As Byte
Dim Z1_of_gg As Byte , Z2_of_gg As Byte , Z3_of_gg As Byte , Z4_of_gg As Byte , Z5_of_gg As Byte , Z6_of_gg As Byte , Z7_of_gg As Byte , Z8_of_gg As Byte
Dim Z1_on_mm As Byte , Z2_on_mm As Byte , Z3_on_mm As Byte , Z4_on_mm As Byte , Z5_on_mm As Byte , Z6_on_mm As Byte , Z7_on_mm As Byte , Z8_on_mm As Byte
Dim Z1_of_mm As Byte , Z2_of_mm As Byte , Z3_of_mm As Byte , Z4_of_mm As Byte , Z5_of_mm As Byte , Z6_of_mm As Byte , Z7_of_mm As Byte , Z8_of_mm As Byte
Dim Zm_wysw As Byte , Pcf8574_panel As Byte , Zawory As Byte , Flaga_zawory As Byte , Wskazniki As Byte
Dim Godziny As Byte , Minuty As Byte
Dim Migaj As Bit , Menu As Byte , Menu_zaw As Byte
Dim H As Byte , M As Byte , S As Byte
Dim Praca As Bit
Dim On_off As Bit
Dim Zapisz_dane As Bit
Dim Error As Bit
Dim Pcf8574 As Byte
Dim Pomoc_wskazniki As Byte , Pomoc_zawory As Byte , Pomoc_pcf8574 As Byte , Startuj As Bit , Flaga As Bit
'============================================odblokowanie przerwa=====================================================
Enable Interrupts
Enable Ovf0
Enable Ovf1
'===============================================start watchdoga========================================================
Start Watchdog
'=======================================wpisanie wartosci pocztkowych=================================================
Zawory = 255
Wskazniki = 255
Pcf8574 = 255
Licznik = 0
Call Odczyt_pamieci
'===============================================ptla do loop===========================================================
Do
   Reset Watchdog                                           'odczyt kodu z pilota zdalnego sterowania
   If Pind.2 = 0 Then                                       'sprawdzaj stan pinu jeli jest niski
      Waitms 75
      If Flaga = 1 Then                                     'sprawdzaj czy jest ustawiona flaga
         Disable Ovf0
         Set L1                                             'zablokuj przerwanie i wyga wszystkie wywietlacze
         Set L2                                             'oraz wskaniki na czas odbioru kodu rc5
         Set L3
         Set L4
         Set Led1
         Set Led2
         Zm_wysw = 0
         Enable Interrupts                                  'odblikowanie przerwa globalnych
          Getrc5(address , Command)                         'odczyt kodu z pilota
          Command = Command And &B01111111                  'maskowanie 8-bitu
         Enable Ovf0                                        'odblikuj przerwanie
         Waitms 500
         Reset Flaga                                        'zeruj flag
      End If
   End If
Loop                                                        'Until Pind.2 = 1
End
'==================================podprogram obsugi od timera 0 wyswietlacz LED=======================================
Wyswietlacz:
  Wysw = Gg_pomoc                                           'godziny
   Wysw_pomoc = Wysw Mod 10
    Jed_godz = Wysw_pomoc
   Wysw = Wysw / 10

   Wysw_pomoc = Wysw Mod 10
    Dzi_godz = Wysw_pomoc
   Wysw = Wysw / 10

  Wysw = Mm_pomoc                                           'minuty
   Wysw_pomoc = Wysw Mod 10
    Jed_min = Wysw_pomoc
   Wysw = Wysw / 10

   Wysw_pomoc = Wysw Mod 10
    Dzi_min = Wysw_pomoc
   Wysw = Wysw / 10

     Set L1
     Set L2
     Set L3
     Set L4
     Set Led1
     Set Led2

  If Zm_wysw < 6 Then I2csend &B01000110 , Pcf8574_panel    'komunikacja tylko wtedy gdy jest obsugiwany wywietlacz

  Select Case Zm_wysw
    Case 0:
      Reset L1
       Pcf8574_panel = Lookup(dzi_godz , Tabela)

    Case 1:
      Reset L2
       Pcf8574_panel = Lookup(jed_godz , Tabela)

    Case 2:
      Reset L3
       Pcf8574_panel = Lookup(dzi_min , Tabela)

    Case 3:
      Reset L4
       Pcf8574_panel = Lookup(jed_min , Tabela)

    Case 4:
      Reset Led1
       Pcf8574_panel = Zawory

    Case 5:
      Reset Led2
       Pcf8574_panel = Wskazniki

    Case 6:
      If Podprogram = 0 Then
        I2cstart                                            'odczyt aktualnego czasu
         I2cwbyte 160                                       'A0 = GND
         I2cwbyte 3                                         'rejestr minut
        I2cstart
         I2cwbyte 161                                       'adres odczytu
         I2crbyte Minuty , Ack
         I2crbyte Godziny , Nack
        I2cstop

        Minuty = Minuty And &B01111111                      'maskowanie
        Godziny = Godziny And &B00111111

        Pomoc_mm = Makedec(minuty)
        Pomoc_gg = Makedec(godziny)
      End If

    Case 7:
      I2csend &B01110000 , Pcf8574                          'komunikacja z ukadem na pycie gwnej

  End Select

  Incr Zm_wysw
  If Zm_wysw > 7 Then Zm_wysw = 0
Return
'=========================================podprogram obsugi od timera 1 program gwny=================================
Przerwanie:
  Disable Ovf1
    Toggle Migaj                                            'zmie ztan zmiennej bitowej na przeciwny
    Set Flaga                                               'ustaw flag

        If Command = 20 Then                                'zwikszanie licznika godzin
           Set On_off                                       'ustaw flag aby po wejciu w podprogram czas otwarcia zoworw by ustawiany jako pierwszy
           Call Program
           Incr Gg_pomoc
           If Gg_pomoc > 23 Then Gg_pomoc = 23
        End If
        If Command = 21 Then                                'zmniejszanie licznika godzin
           Set On_off
           Call Program
           Decr Gg_pomoc
           If Gg_pomoc = 255 Then Gg_pomoc = 0
        End If
        If Command = 16 Then                                'zwikszanie licznika minut
           Set On_off
           Call Program
           Incr Mm_pomoc
           If Mm_pomoc > 59 Then Mm_pomoc = 59
        End If
        If Command = 17 Then                                'zmniejszanie licznika minut
           Set On_off
           Call Program
           Decr Mm_pomoc
           If Mm_pomoc = 255 Then Mm_pomoc = 0
        End If
        If Command = 1 Then : Menu = 1 : Call Program : End If
        If Command = 2 Then : Menu = 2 : Call Program : End If
        If Command = 3 Then : Menu = 3 : Call Program : End If
        If Command = 4 Then : Menu = 4 : Call Program : End If
        If Command = 5 Then : Menu = 5 : Call Program : End If
        If Command = 6 Then : Menu = 6 : Call Program : End If
        If Command = 7 Then : Menu = 7 : Call Program : End If
        If Command = 8 Then : Menu = 8 : Call Program : End If
        If Command = 9 Then : Menu = 9 : Call Program : End If       'zapis czasu do zegara RTC

        If Termnik = 1 Then Error = 1                       'gdy radiator si przegrzeje ustaw flag bdu
        If Czujnik_pustych_zbiornikow = 0 Then Error = 1    'gdy zbiorniki s puste ustaw flag bdu
        If Czujnik_pustych_zbiornikow = 1 And Termnik = 0 Then
           Error = 0                                        'gdy radiator jest chodny i jest woda w zbiornikach skasuj flag bdu
        End If

        If Czujnik_pelnych_zbiornikow = 0 Then              'gdy opadnie poziom wody w zbiornikach
           Dodatkowa_pompa = 1                              'wcz pomp dodatkow w celo dopuszczenia wody do pena
        Else                                                'gdy zbiorniki pene
           Dodatkowa_pompa = 0                              'wycz dodatkow pomp
        End If

  If Podprogram = 1 Then

     Wskazniki.5 = 0                                        'dwukropek swieci cay czas
     If Command = 12 Then : Reset On_off : Licznik = 0 : End If
     If On_off = 1 Then                                     'sprawdzanie stanu
        Reset Wskazniki.6
        Set Wskazniki.7
     Else
        Set Wskazniki.6
        Reset Wskazniki.7
     End If

     Incr Licznik
     If Licznik > 10 Then : Menu = 0 : Menu_zaw = 0 : Reset Podprogram : End If

     Select Case Menu
       Case 0:
         Zawory = 255                                       'wyga lampki zaworw
       Case 1:
         Reset Zawory.0
         If On_off = 1 Then                                 'czas otwarcia zaworu
            Z1_on_gg = Gg_pomoc
            Z1_on_mm = Mm_pomoc
         Else                                               'czas zamknicia zaworu
            Z1_of_gg = Gg_pomoc
            Z1_of_mm = Mm_pomoc
         End If
       Case 2:
         Reset Zawory.1
         If On_off = 1 Then                                 'czas otwarcia zaworu
            Z2_on_gg = Gg_pomoc
            Z2_on_mm = Mm_pomoc
         Else                                               'czas zamknicia zaworu
            Z2_of_gg = Gg_pomoc
            Z2_of_mm = Mm_pomoc
         End If
       Case 3:
         Reset Zawory.2
         If On_off = 1 Then                                 'czas otwarcia zaworu
            Z3_on_gg = Gg_pomoc
            Z3_on_mm = Mm_pomoc
         Else                                               'czas zamknicia zaworu
            Z3_of_gg = Gg_pomoc
            Z3_of_mm = Mm_pomoc
         End If
       Case 4:
         Reset Zawory.3
         If On_off = 1 Then                                 'czas otwarcia zaworu
            Z4_on_gg = Gg_pomoc
            Z4_on_mm = Mm_pomoc
         Else                                               'czas zamknicia zaworu
            Z4_of_gg = Gg_pomoc
            Z4_of_mm = Mm_pomoc
         End If
       Case 5:
         Reset Zawory.4
         If On_off = 1 Then                                 'czas otwarcia zaworu
            Z5_on_gg = Gg_pomoc
            Z5_on_mm = Mm_pomoc
         Else                                               'czas zamknicia zaworu
            Z5_of_gg = Gg_pomoc
            Z5_of_mm = Mm_pomoc
         End If
       Case 6:
         Reset Zawory.5
         If On_off = 1 Then                                 'czas otwarcia zaworu
            Z6_on_gg = Gg_pomoc
            Z6_on_mm = Mm_pomoc
         Else                                               'czas zamknicia zaworu
            Z6_of_gg = Gg_pomoc
            Z6_of_mm = Mm_pomoc
         End If
       Case 7:
         Reset Zawory.6
         If On_off = 1 Then                                 'czas otwarcia zaworu
            Z7_on_gg = Gg_pomoc
            Z7_on_mm = Mm_pomoc
         Else                                               'czas zamknicia zaworu
            Z7_of_gg = Gg_pomoc
            Z7_of_mm = Mm_pomoc
         End If
       Case 8:
         Reset Zawory.7
         If On_off = 1 Then                                 'czas otwarcia zaworu
            Z8_on_gg = Gg_pomoc
            Z8_on_mm = Mm_pomoc
         Else                                               'czas zamknicia zaworu
            Z8_of_gg = Gg_pomoc
            Z8_of_mm = Mm_pomoc
         End If
       Case 9:
         Disable Ovf0
           Set L1                                           'na czas zapisu czasu do zagaea czasu rzeczywistego wyga wywietlacze
           Set L2
           Set L3
           Set L4
           Set Led1
           Set Led2

           H = Makebcd(gg_pomoc)
           M = Makebcd(mm_pomoc)
           S = Makebcd(0)

           I2cstart
            I2cwbyte 160
            I2cwbyte 0                                      'rejestr kontrolny
            I2cwbyte 8                                      'ustawienie rejestru zapisu daty
           I2cstop
           I2cstart
            I2cwbyte 160
            I2cwbyte 2
            I2cwbyte S
            I2cwbyte M
            I2cwbyte H
           I2cstop
           Licznik = 10
         Enable Ovf0
     End Select                                             'wyga lampki zaworw

  Else

'=====================kontrola zaniku wody i czujnik termiczny========================

     If Zapisz_dane = 1 Then                                'gdy flaga ustawiona zapisz dane
        Zawory = 255
        Call Zapisz_pamiec                                  'wywoanie procedury zapisu pamici eeprom
     End If

     If Command = 12 Then
        Toggle Startuj                                      'start lub stop sterownika
     End If

     If Command = 32 Then                                   'wywoaj procedur odzczytu czasuw otwierania i zamykania zaworw
        Menu_zaw = 1
        Zawory = 255                                        'po naciniciu wyga lampki zaworw
     End If

     If Migaj = 1 Then                                      'sprawdza bit migaj i dwukropek wywietlacza LED miga
        Wskazniki.5 = 0
     Else
        Wskazniki.5 = 1
     End If

     If Error = 1 Then                                      'jesli flaga bdu ustawiona
        Wskazniki.1 = 0                                     'zapal lampk
     Else                                                   'flaga bedu nie jest ustawiona
        Wskazniki.1 = 1                                     'zapal lampke
     End If

     Select Case Menu_zaw
       Case 0:
          Licznik = 0                                       'zeruj zmienn licznik
          Gg_pomoc = Pomoc_gg
          Mm_pomoc = Pomoc_mm
          If Startuj = 1 Then                               'sterownik pracuje
             Wskazniki.6 = 0                                'zapal obydwie lampki
             Wskazniki.7 = 0
             If Z1_on_gg = Pomoc_gg And Z1_on_mm = Pomoc_mm Then       'czas otwarcia zaworu nr.1
                Flaga_zawory.0 = 0
                Pcf8574.0 = 0                               'otwieraj zawr nr.1
             End If
             If Z2_on_gg = Pomoc_gg And Z2_on_mm = Pomoc_mm Then       'czas otwarcia zaworu nr.2
                Flaga_zawory.1 = 0
                Pcf8574.1 = 0                               'otwieraj zawr nr.2
             End If
             If Z3_on_gg = Pomoc_gg And Z3_on_mm = Pomoc_mm Then       'czas otwarcia zaworu nr.3
                Flaga_zawory.2 = 0
                Pcf8574.2 = 0                               'otwieraj zawr nr.3
             End If
             If Z4_on_gg = Pomoc_gg And Z4_on_mm = Pomoc_mm Then       'czas otwarcia zaworu nr.4
                Flaga_zawory.3 = 0
                Pcf8574.3 = 0                               'otwieraj zawr nr.4
             End If
             If Z5_on_gg = Pomoc_gg And Z5_on_mm = Pomoc_mm Then       'czas otwarcia zaworu nr.5
                Flaga_zawory.4 = 0
                Pcf8574.4 = 0                               'otwieraj zawr nr.5
             End If
             If Z6_on_gg = Pomoc_gg And Z6_on_mm = Pomoc_mm Then       'czas otwarcia zaworu nr.6
                Flaga_zawory.5 = 0
                Pcf8574.5 = 0                               'otwieraj zawr nr.6
             End If
             If Z7_on_gg = Pomoc_gg And Z7_on_mm = Pomoc_mm Then       'czas otwarcia zaworu nr.7
                Flaga_zawory.6 = 0
                Pcf8574.6 = 0                               'otwieraj zawr nr.7
             End If
             If Z8_on_gg = Pomoc_gg And Z8_on_mm = Pomoc_mm Then       'czas otwarcia zaworu nr.8
                Flaga_zawory.7 = 0
                Pcf8574.7 = 0                               'otwieraj zawr nr.8
             End If

             If Z1_of_gg = Pomoc_gg And Z1_of_mm = Pomoc_mm Then : Flaga_zawory.0 = 1 : Pcf8574.0 = 1 : End If
             If Z2_of_gg = Pomoc_gg And Z2_of_mm = Pomoc_mm Then : Flaga_zawory.1 = 1 : Pcf8574.1 = 1 : End If
             If Z3_of_gg = Pomoc_gg And Z3_of_mm = Pomoc_mm Then : Flaga_zawory.2 = 1 : Pcf8574.2 = 1 : End If
             If Z4_of_gg = Pomoc_gg And Z4_of_mm = Pomoc_mm Then : Flaga_zawory.3 = 1 : Pcf8574.3 = 1 : End If
             If Z5_of_gg = Pomoc_gg And Z5_of_mm = Pomoc_mm Then : Flaga_zawory.4 = 1 : Pcf8574.4 = 1 : End If
             If Z6_of_gg = Pomoc_gg And Z6_of_mm = Pomoc_mm Then : Flaga_zawory.5 = 1 : Pcf8574.5 = 1 : End If
             If Z7_of_gg = Pomoc_gg And Z7_of_mm = Pomoc_mm Then : Flaga_zawory.6 = 1 : Pcf8574.6 = 1 : End If
             If Z8_of_gg = Pomoc_gg And Z8_of_mm = Pomoc_mm Then : Flaga_zawory.7 = 1 : Pcf8574.7 = 1 : End If

          Else                                              'sterownik stop
             Flaga_zawory = 255                             'zamknij wszystkie zawory i wycz pomp
             Pcf8574 = 255                                  'zga wszystkie lampki zaworw
             Wskazniki.6 = 1                                'zga lampk on
             Wskazniki.7 = 1                                'zgas lampk off
          End If

          Zawory = Flaga_zawory

          If Pomoc_wskazniki <> Wskazniki Then : Writeeeprom Wskazniki , 34 : End If       'zapisuj tylko raz zmienn do pamici nieulotnej
          If Pomoc_zawory <> Zawory Then : Writeeeprom Flaga_zawory , 35 : End If
          If Pomoc_pcf8574 <> Pcf8574 Then : Writeeeprom Pcf8574 , 36 : End If

          Pomoc_wskazniki = Wskazniki                       'potem przepisz zawarto
          Pomoc_zawory = Zawory
          Pomoc_pcf8574 = Pcf8574

          If Pcf8574 <> 255 Then                            'pomp wczaj jeli otwoy si ktry z zaworw
             If Error = 0 And Czujnik_deszczu = 1 Then Reset Pompa       'pompa pracuje jeli nie ma bdw i nie pada deszcz
             If Error = 0 And Czujnik_deszczu = 0 Then Set Pompa       'pompa nie pracuje jeli nie ma bdu ale pada deszcz
             If Error = 1 Then Set Pompa                    'pompa nie pracuje jeli jest bd
          Else
             Set Pompa                                      'wycz pomp jeli wszystkie zawory zamknite
          End If

       Case 1:
          If Migaj = 1 Then : Zawory.0 = 0 : Else : Zawory.0 = 1 : End If
          Incr Licznik
           If Licznik = 1 Then                              'czas otwarcia zoworu
              Reset Wskazniki.6
              Set Wskazniki.7
              Gg_pomoc = Z1_on_gg
              Mm_pomoc = Z1_on_mm
           End If
           If Licznik = 15 Then                             'czas zamknicia zaworu
              Set Wskazniki.6
              Reset Wskazniki.7
              Gg_pomoc = Z1_of_gg
              Mm_pomoc = Z1_of_mm
           End If
           If Licznik = 31 Then : Licznik = 0 : Menu_zaw = 2 : Zawory.0 = 0 : End If

       Case 2:
          If Migaj = 1 Then : Zawory.1 = 0 : Else : Zawory.1 = 1 : End If
          Incr Licznik
           If Licznik = 1 Then                              'czas otwarcia zoworu
              Reset Wskazniki.6
              Set Wskazniki.7
              Gg_pomoc = Z2_on_gg
              Mm_pomoc = Z2_on_mm
           End If
           If Licznik = 15 Then                             'czas zamknicia zaworu
              Set Wskazniki.6
              Reset Wskazniki.7
              Gg_pomoc = Z2_of_gg
              Mm_pomoc = Z2_of_mm
           End If
           If Licznik = 31 Then : Licznik = 0 : Menu_zaw = 3 : Zawory.1 = 0 : End If

       Case 3:
          If Migaj = 1 Then : Zawory.2 = 0 : Else : Zawory.2 = 1 : End If
          Incr Licznik
           If Licznik = 1 Then                              'czas otwarcia zoworu
              Reset Wskazniki.6
              Set Wskazniki.7
              Gg_pomoc = Z3_on_gg
              Mm_pomoc = Z3_on_mm
           End If
           If Licznik = 15 Then                             'czas zamknicia zaworu
              Set Wskazniki.6
              Reset Wskazniki.7
              Gg_pomoc = Z3_of_gg
              Mm_pomoc = Z3_of_mm
           End If
           If Licznik = 31 Then : Licznik = 0 : Menu_zaw = 4 : Zawory.2 = 0 : End If

       Case 4:
          If Migaj = 1 Then : Zawory.3 = 0 : Else : Zawory.3 = 1 : End If
          Incr Licznik
           If Licznik = 1 Then                              'czas otwarcia zoworu
              Reset Wskazniki.6
              Set Wskazniki.7
              Gg_pomoc = Z4_on_gg
              Mm_pomoc = Z4_on_mm
           End If
           If Licznik = 15 Then                             'czas zamknicia zaworu
              Set Wskazniki.6
              Reset Wskazniki.7
              Gg_pomoc = Z4_of_gg
              Mm_pomoc = Z4_of_mm
           End If
           If Licznik = 31 Then : Licznik = 0 : Menu_zaw = 5 : Zawory.3 = 0 : End If

       Case 5:
          If Migaj = 1 Then : Zawory.4 = 0 : Else : Zawory.4 = 1 : End If
          Incr Licznik
           If Licznik = 1 Then                              'czas otwarcia zoworu
              Reset Wskazniki.6
              Set Wskazniki.7
              Gg_pomoc = Z5_on_gg
              Mm_pomoc = Z5_on_mm
           End If
           If Licznik = 15 Then                             'czas zamknicia zaworu
              Set Wskazniki.6
              Reset Wskazniki.7
              Gg_pomoc = Z5_of_gg
              Mm_pomoc = Z5_of_mm
           End If
           If Licznik = 31 Then : Licznik = 0 : Menu_zaw = 6 : Zawory.4 = 0 : End If

       Case 6:
          If Migaj = 1 Then : Zawory.5 = 0 : Else : Zawory.5 = 1 : End If
          Incr Licznik
           If Licznik = 1 Then                              'czas otwarcia zoworu
              Reset Wskazniki.6
              Set Wskazniki.7
              Gg_pomoc = Z6_on_gg
              Mm_pomoc = Z6_on_mm
           End If
           If Licznik = 15 Then                             'czas zamknicia zaworu
              Set Wskazniki.6
              Reset Wskazniki.7
              Gg_pomoc = Z6_of_gg
              Mm_pomoc = Z6_of_mm
           End If
           If Licznik = 31 Then : Licznik = 0 : Menu_zaw = 7 : Zawory.5 = 0 : End If

       Case 7:
          If Migaj = 1 Then : Zawory.6 = 0 : Else : Zawory.6 = 1 : End If
          Incr Licznik
           If Licznik = 1 Then                              'czas otwarcia zoworu
              Reset Wskazniki.6
              Set Wskazniki.7
              Gg_pomoc = Z7_on_gg
              Mm_pomoc = Z7_on_mm
           End If
           If Licznik = 15 Then                             'czas zamknicia zaworu
              Set Wskazniki.6
              Reset Wskazniki.7
              Gg_pomoc = Z7_of_gg
              Mm_pomoc = Z7_of_mm
           End If
           If Licznik = 31 Then : Licznik = 0 : Menu_zaw = 8 : Zawory.6 = 0 : End If

       Case 8:
          If Migaj = 1 Then : Zawory.7 = 0 : Else : Zawory.7 = 1 : End If
          Incr Licznik
           If Licznik = 1 Then                              'czas otwarcia zoworu
              Reset Wskazniki.6
              Set Wskazniki.7
              Gg_pomoc = Z8_on_gg
              Mm_pomoc = Z8_on_mm
           End If
           If Licznik = 15 Then                             'czas zamknicia zaworu
              Set Wskazniki.6
              Reset Wskazniki.7
              Gg_pomoc = Z8_of_gg
              Mm_pomoc = Z8_of_mm
           End If
           If Licznik = 31 Then : Licznik = 0 : Menu_zaw = 0 : Zawory = 255 : End If
     End Select
  End If
  Command = 0
  Enable Ovf1
Return

'======================procedura wywoywana po wejsciu w podprogram ustawja flag i kasuje licznik======================
Sub Program:
   Set Podprogram
   Set Zapisz_dane                                          'ustaw flag zapisu danych do pamieci nieolotnej
   Licznik = 0
End Sub
'=============================procedura zapisu danych do pamici nieulotnej procesora===================================
Sub Zapisz_pamiec:
   Disable Ovf0                                             'zablokuj przerwania od timera0
     Set L1                                                 'na czas zapisu pamieci wyga wywietlacze
     Set L2
     Set L3
     Set L4
     Set Led1
     Set Led2
     Writeeeprom Z1_on_gg , 2                               'zapisz zmienne do odpowiednich komurek pamieci eeprom
     Writeeeprom Z1_on_mm , 3
     Writeeeprom Z1_of_gg , 4
     Writeeeprom Z1_of_mm , 5
     Writeeeprom Z2_on_gg , 6
     Writeeeprom Z2_on_mm , 7
     Writeeeprom Z2_of_gg , 8
     Writeeeprom Z2_of_mm , 9
     Writeeeprom Z3_on_gg , 10
     Writeeeprom Z3_on_mm , 11
     Writeeeprom Z3_of_gg , 12
     Writeeeprom Z3_of_mm , 13
     Writeeeprom Z4_on_gg , 14
     Writeeeprom Z4_on_mm , 15
     Writeeeprom Z4_of_gg , 16
     Writeeeprom Z4_of_mm , 17
     Writeeeprom Z5_on_gg , 18
     Writeeeprom Z5_on_mm , 19
     Writeeeprom Z5_of_gg , 20
     Writeeeprom Z5_of_mm , 21
     Writeeeprom Z6_on_gg , 22
     Writeeeprom Z6_on_mm , 23
     Writeeeprom Z6_of_gg , 24
     Writeeeprom Z6_of_mm , 25
     Writeeeprom Z7_on_gg , 26
     Writeeeprom Z7_on_mm , 27
     Writeeeprom Z7_of_gg , 28
     Writeeeprom Z7_of_mm , 29
     Writeeeprom Z8_on_gg , 30
     Writeeeprom Z8_on_mm , 31
     Writeeeprom Z8_of_gg , 32
     Writeeeprom Z8_of_mm , 33
    Reset Zapisz_dane                                       'kasuj flag po zapisie do pamici aby zapis nastpowa tylko raz
   Enable Ovf0                                              'odblokuj przerwanie od timera0
End Sub
'===========================procedura odczytu pamici nieulotnej wywoywana po wczeniu zasilania======================
Sub Odczyt_pamieci:
   Readeeprom Z1_on_gg , 2
   Readeeprom Z1_on_mm , 3
   Readeeprom Z1_of_gg , 4
   Readeeprom Z1_of_mm , 5
   Readeeprom Z2_on_gg , 6
   Readeeprom Z2_on_mm , 7
   Readeeprom Z2_of_gg , 8
   Readeeprom Z2_of_mm , 9
   Readeeprom Z3_on_gg , 10
   Readeeprom Z3_on_mm , 11
   Readeeprom Z3_of_gg , 12
   Readeeprom Z3_of_mm , 13
   Readeeprom Z4_on_gg , 14
   Readeeprom Z4_on_mm , 15
   Readeeprom Z4_of_gg , 16
   Readeeprom Z4_of_mm , 17
   Readeeprom Z5_on_gg , 18
   Readeeprom Z5_on_mm , 19
   Readeeprom Z5_of_gg , 20
   Readeeprom Z5_of_mm , 21
   Readeeprom Z6_on_gg , 22
   Readeeprom Z6_on_mm , 23
   Readeeprom Z6_of_gg , 24
   Readeeprom Z6_of_mm , 25
   Readeeprom Z7_on_gg , 26
   Readeeprom Z7_on_mm , 27
   Readeeprom Z7_of_gg , 28
   Readeeprom Z7_of_mm , 29
   Readeeprom Z8_on_gg , 30
   Readeeprom Z8_on_mm , 31
   Readeeprom Z8_of_gg , 32
   Readeeprom Z8_of_mm , 33
   Readeeprom Wskazniki , 34
   Readeeprom Flaga_zawory , 35
   Readeeprom Pcf8574 , 36
   If Wskazniki.0 = 1 Then : Startuj = 1 : Else : Startuj = 0 : End If
End Sub

Tabela:
Data 129 , 207 , 146 , 134 , 204 , 164 , 160 , 143 , 128 , 132